//+------------------------------------------------------------------+
//|                                      IndicatorAddRemoveEvent.mqh |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property strict

void IndicatorAddRemoveEvent(const int id){

   static bool fs=false;

   static string pn[];
   static int pc[];
   static int pcnt=0;   

   static string n[];
   static int c[];
   ArrayInitialize(c,0);
   int cnt=0;
   
   if(id==CHARTEVENT_CHART_CHANGE){
      for(int i=0;i<ChartGetInteger(0,CHART_WINDOWS_TOTAL);i++){
         for(int j=0;j<ChartIndicatorsTotal(0,i);j++){
            if(ChartIndicatorName(0,i,j)!=WindowExpertName()){
               bool ex=false;
               for(int k=0;k<cnt;k++){
                  if(ChartIndicatorName(0,i,j)==n[k]){
                     c[k]++;
                     ex=true;
                     break;     
                  }
               }
               if(!ex){
                  if(cnt>=ArraySize(n)){
                     ArrayResize(n,cnt+32);
                     ArrayResize(c,cnt+32);
                  }
                  n[cnt]=ChartIndicatorName(0,i,j);
                  c[cnt]=1;
                  cnt++;
               }
            }
         }
      }
      
      if(fs){
         for(int i=0;i<cnt;i++){
            bool evnt=true;
            for(int j=0;j<pcnt;j++){
               if(n[i]==pn[j]){
                  if(c[i]>pc[j]){
                     for(int l=0;l<c[i]-pc[j];l++){
                        IndicatorAddRemoveOnEvent(n[i],1);              
                     }
                  }
                  else if(c[i]<pc[j]){
                     for(int l=0;l<pc[j]-c[i];l++){
                        IndicatorAddRemoveOnEvent(n[i],0);   
                     }
                  }
                  evnt=false;
                  break;
               }
            }
            if(evnt){
               IndicatorAddRemoveOnEvent(n[i],1);
            }
         }
         
         
         for(int i=0;i<pcnt;i++){
            bool ex=false;
            for(int j=0;j<cnt;j++){
               if(pn[i]==n[j]){
                  ex=true;
                  break;
               }
            }
            if(!ex){
               IndicatorAddRemoveOnEvent(pn[i],0);          
            }
         }
      }
      else{
         fs=true;
      }
      
      ArrayCopy(pn,n,0,0,cnt);
      ArrayCopy(pc,c,0,0,cnt);      
         
      pcnt=cnt;

   }
   
   
}
